precision mediump float; 
uniform sampler2D u_Texture0; 
uniform sampler2D u_Texture1;
uniform sampler2D u_Texture2;
uniform sampler2D u_Texture3;
uniform sampler2D u_Texture4;
uniform sampler2D u_Texture5;
varying vec2 v_TexCoordinate;
mat3 saturateMatrix = mat3(
                            1.105150,
                            -0.044850,
                            -0.046000,
                            -0.088050,
                            1.061950,
                            -0.089200,
                            -0.017100,
                            -0.017100,
                            1.132900);

 vec3 luma = vec3(.3, .59, .11);
void main()
{
	vec3 texel = texture2D(u_Texture0, v_TexCoordinate).rgb;

    vec2 lookup;
    lookup.y = 0.5;
    lookup.x = texel.r;
    texel.r = texture2D(u_Texture1, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(u_Texture1, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(u_Texture1, lookup).b;

    texel = saturateMatrix * texel;


    vec2 tc = (2.0 * v_TexCoordinate) - 1.0;
    float d = dot(tc, tc);
    vec3 sampled;
    lookup.y = 0.5;
    lookup.x = texel.r;
    sampled.r = texture2D(u_Texture2, lookup).r;
    lookup.x = texel.g;
    sampled.g = texture2D(u_Texture2, lookup).g;
    lookup.x = texel.b;
    sampled.b = texture2D(u_Texture2, lookup).b;
    float value = smoothstep(0.0, 1.0, d);
    texel = mix(sampled, texel, value);

    lookup.x = texel.r;
    texel.r = texture2D(u_Texture3, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(u_Texture3, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(u_Texture3, lookup).b;


    lookup.x = dot(texel, luma);
    texel = mix(texture2D(u_Texture4, lookup).rgb, texel, .5);

    lookup.x = texel.r;
    texel.r = texture2D(u_Texture5, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(u_Texture5, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(u_Texture5, lookup).b;

    gl_FragColor = vec4(texel, 1.0);

}