precision mediump float; 
uniform sampler2D u_Texture0; 
uniform sampler2D u_Texture1;
uniform sampler2D u_Texture2;
uniform sampler2D u_Texture3;
uniform sampler2D u_Texture4;
uniform sampler2D u_Texture5;
varying vec2 v_TexCoordinate;
void main()
{
	vec3 texel = texture2D(u_Texture0, v_TexCoordinate).rgb;
    vec3 edge = texture2D(u_Texture1, v_TexCoordinate).rgb;
    texel = texel * edge;

    texel = vec3(
        texture2D(u_Texture2, vec2(texel.r, .16666)).r,
        texture2D(u_Texture2, vec2(texel.g, .5)).g,
        texture2D(u_Texture2, vec2(texel.b, .83333)).b
    );

    vec3 luma = vec3(.30, .59, .11);
    vec3 gradSample = texture2D(u_Texture3, vec2(dot(luma, texel), .5)).rgb;
    vec3 final = vec3(
        texture2D(u_Texture4, vec2(gradSample.r, texel.r)).r,
        texture2D(u_Texture4, vec2(gradSample.g, texel.g)).g,
        texture2D(u_Texture4, vec2(gradSample.b, texel.b)).b
    );

    vec3 metal = texture2D(u_Texture5, v_TexCoordinate).rgb;
    vec3 metaled = vec3(
        texture2D(u_Texture4, vec2(metal.r, texel.r)).r,
        texture2D(u_Texture4, vec2(metal.g, texel.g)).g,
        texture2D(u_Texture4, vec2(metal.b, texel.b)).b
    );

    gl_FragColor = vec4(metaled, 1.0);



}