precision mediump float; 
uniform sampler2D u_Texture0; 
uniform sampler2D u_Texture1;
uniform sampler2D u_Texture2;
uniform sampler2D u_Texture3;
uniform sampler2D u_Texture4;
uniform sampler2D u_Texture5;
varying vec2 v_TexCoordinate;
void main()
{
	vec3 texel = texture2D(u_Texture0, v_TexCoordinate).rgb;

    vec2 tc = (2.0 * v_TexCoordinate) - 1.0;
    float d = dot(tc, tc);
    vec2 lookup = vec2(d, texel.r);
    texel.r = texture2D(u_Texture1, lookup).r;
    lookup.y = texel.g;
    texel.g = texture2D(u_Texture1, lookup).g;
    lookup.y = texel.b;
    texel.b	= texture2D(u_Texture1, lookup).b;

    vec3 rgbPrime = vec3(0.1019, 0.0, 0.0);
    float m = dot(vec3(.3, .59, .11), texel.rgb) - 0.03058;
    texel = mix(texel, rgbPrime + m, 0.32);

    vec3 metal = texture2D(u_Texture2,  v_TexCoordinate).rgb;
    texel.r = texture2D(u_Texture3, vec2(metal.r, texel.r)).r;
    texel.g = texture2D(u_Texture3, vec2(metal.g, texel.g)).g;
    texel.b = texture2D(u_Texture3, vec2(metal.b, texel.b)).b;

    texel = texel * texture2D(u_Texture4,  v_TexCoordinate).rgb;

    texel.r = texture2D(u_Texture5, vec2(texel.r, .16666)).r;
    texel.g = texture2D(u_Texture5, vec2(texel.g, .5)).g;
    texel.b = texture2D(u_Texture5, vec2(texel.b, .83333)).b;


    gl_FragColor = vec4(texel, 1.0);



}