precision mediump float;
uniform sampler2D u_Texture0; 
uniform sampler2D u_Texture1;
uniform sampler2D u_Texture2;
varying vec2 v_TexCoordinate;
void main()
{
	vec3 texel = texture2D(u_Texture0, v_TexCoordinate).rgb;

	vec2 tc = (2.0 * v_TexCoordinate) - 1.0;
	float d = dot(tc, tc);
	vec2 lookup = vec2(d, texel.r);
	texel.r = texture2D(u_Texture2, lookup).r;
	lookup.y = texel.g;
	texel.g = texture2D(u_Texture2, lookup).g;
	lookup.y = texel.b;
	texel.b	= texture2D(u_Texture2, lookup).b;

	vec2 red = vec2(texel.r, 0.16666);
	vec2 green = vec2(texel.g, 0.5);
	vec2 blue = vec2(texel.b, .83333);
	texel.r = texture2D(u_Texture1, red).r;
	texel.g = texture2D(u_Texture1, green).g;
	texel.b = texture2D(u_Texture1, blue).b;

	gl_FragColor = vec4(texel, 1.0);


}